﻿//Numerator (CS3, CS4, CS5)(v.3).jsx
// © Михаил Иванюшин 2011. ivanyushin@yandex.ru
//
// Последовательная нумерация в верстке.
// Для выполнения нумерации пользователь рисует на мастер-странице текстовый фрейм и присваивает ему метку. 
// Если на мастер-странице создано несколько фреймов с такой меткой, в них будут помещены последовательные номера.
// Этот фрейм (или фреймы, если их несколько с одинаковой меткой) перемещается на отдельный слой.
// В верстке добавляется нужное число страниц.
// В палитре слоев гасятся все слои, кроме того, на котором этот фрейм для нумерации.
// В верстке выбираются все страницы и разрывается их связь с мастер-страницей (команда из контекстного меню (правая кнопка мыши) Override All Master Page Items,  или эта же команда из меню палитры Pages ).
// Тот факт, что сейчас в палитре слоев активен только слой с номером, гарантирует, что в результате в верстке от мастера-страниц будут отсоединены только фреймы для номеров.
// Все другое оформление документа осталось привязанным к мастерам, .т.к. в момент разрыва страниц верстки с мастер-страницами слои с оформлением издания были отключены.
// Оформление текста записи с номером определяется установками, сделанными при создании этого фрейма.
// Перед запуском скрипта на любой странице верстки должен быть выбран фрейм, в котором будет один из номеров.
// После запуска скрипта:
// 1) определяется текст до и после номера, если это нужно; 
// 2) задается начальный номер и число разрядов числа -- т.е. если ввести 1, то номера будут 1,2,...,9, 10, 11... , а если ввести 000001, то номера будут 000001, 000002, 000003...
// В процессе нумерации скрипт ищет на полосах фреймы с нужной меткой и  в каждом таком фрейме помещает очередной номер. 
// По завершении работы скрипта выводится информация о параметрах нумерации, время работы скрипта и значение темпа нумерации -- сколько миллисекунд требовалось на один номер.
// Параметры нумерации сохраняются, и при повторном запуске помещаются в окно диалога скрипта.
//
// Практическая рекомендация -- не увлекайтесь расстановкой большого числа номеров за один раз, 500-600 не больше. 
// Работа в 10 привёрток по 600 номеров будет сделана быстрее, чем за один раз 6000 номеров.
//

#target indesign
#targetengine "session"
// http://forums.adobe.com/message/3152162#3152162
var ProgressBar = function(/*str*/title)
{
     var w = new Window('palette', title, {x:0, y:0, width:640, height:60},{closeButton: false}),
          pb = w.add('progressbar', {x:20, y:32, width:600, height:12}, 0, 100),
          st = w.add('statictext', {x:20, y:12, width:600, height:20});
     st.justify = 'left';
     w.center();
     this.reset = function(msg,maxValue)
          {
          st.text = msg;
          pb.value = 0;
          pb.maxvalue = maxValue||0;
          pb.visible = !!maxValue;
          w.show();
          };
     this.hit = function() {++pb.value;};
     this.hide = function() {w.hide();};
     this.close = function() {w.close();};
}

function main() {
var myTxtFrames = new Array;
my_NEXT_FRAME = 1313235563;
ProgramTitul = " Нумератор (18.04.2011)";
var myC, myT, myTB, myTA, mySС, mySN;
var myT1, myT2, myNN, myStp;
var myArrRez = Array;
if (app.documents.length != 0)  { // app.doc 
var mySelection = app.selection[0];
var myDocument = app.documents.item(0);	
if(app.selection.length == 1)  { // ==1
switch(mySelection.constructor.name) { // switch
case "TextFrame":
if (mySelection.label.length == 0) {
	alert("Выделенный текстовый фрейм не имеет метки.",ProgramTitul);
	exit();
	}
var myLabel = mySelection.label;
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +"Numerator.ini");
var mySetInfoFile = new File (myFilePath);
if (mySetInfoFile.exists) { //File.exists
	mySetInfoFile.open("r");
	myT1 = mySetInfoFile.readln(); // текст перед номером
	myT2 = mySetInfoFile.readln(); // текст после номера
	myNN = mySetInfoFile.readln(); // стартовый номер
	myStp = mySetInfoFile.readln(); // шаг нумерации
	//myShPB = mySetInfoFile.readln(); // нужен или нет прогрессбар
	mySetInfoFile.close();
} //File.exists
else {
myT1 = "";
myT2 = "";
myNN = "1";
myStp = "1";
myShPB = 1;
}	
var myWindow = new Window ("dialog",ProgramTitul);  
myWindow.orientation = "column";
myWindow.alignChildren = "top";
myWindow.alignChildren = "right";
var myInputGroup1 = myWindow.add ("group");
myInputGroup1.add ("statictext", undefined, "Текст перед номером");
var myText1 = myInputGroup1.add ("edittext", undefined, myT1);
myText1.characters = 18;
var myInputGroup2 = myWindow.add ("group");
myInputGroup2.add ("statictext", undefined, "Текст после номера");
var myText2 = myInputGroup2.add ("edittext", undefined, myT2);
myText2.characters = 18;
var mySeparateSpace1 = myWindow.add ("group");
mySeparateSpace1.orientation = "column";
mySeparateSpace1.add ("statictext", undefined, "");
var myCount = myWindow.add ("group");
myCount.orientation = "row";
myCount.add ("statictext", undefined, "Нумеровать с");
var myStartNumber = myCount.add ("edittext", undefined, myNN);
myStartNumber.characters = 6;
myCount.add ("statictext", undefined, "Шаг наращения");
var myStep = myCount.add ("edittext", undefined, myStp);
myStep.characters = 3;
/*
var myPB = myWindow.add ("group");
var myBarShow = myPB.add ("checkbox", undefined, "Отображать состояние процесса нумерации");
if (myShPB == 1) myBarShow.value = true;
else myBarShow.value = false;
*/
var mySeparateSpace2 = myWindow.add ("group");
mySeparateSpace2.add ("statictext", undefined, "");
var myButtonGroup = myWindow.add ("group");
myButtonGroup.orientation = "row";
myButtonGroup.add ("button", undefined, "OK");
myButtonGroup.add ("button", undefined, "Cancel");
myButtonGroup.add ("statictext", undefined, "© adobeindesign.ru");
if (myWindow.show() == 1) {
	myArrRez[0] = myText1.text;
	myArrRez[1] = myText2.text;
	myArrRez[2] = myStartNumber.text;
	myArrRez[3] = myStep.text;
	/*
	if (myBarShow.value == true) myArrRez[4] = 1;
	else myArrRez[4] = 0;
	*/
	myArrRez[4] = 1;
}
else exit();
myTA = myArrRez[1];
myTB = myArrRez[0];
mySС = myArrRez[2];
myIncr = Number(myArrRez[3]);
mySN = Number(mySС); // извлекли номер из текстовой строки
if ((myArrRez[2].length == 0) || (myArrRez[3].length == 0)) {
	alert ("Ошибка при вводе данных в поле варианта указания начала нумерации или шага наращения счетчика.\nПо крайней мере одно из этих полей пустое.",ProgramTitul);
	exit();
	}
myRL = String(mySС).length; // узнали, сколько разрядов отведено для номера
if (((mySN >= 0) == false)  || ((myIncr>= 0) == false)) {
	alert ("Ошибка при вводе данных в поле варианта указания начала нумерации или шага наращения счетчика.\nИли введенное число отрицательное, или в поле ввода есть знаки, не являющиеся цифрами.",ProgramTitul);
	exit();
	}
var mySetProcFile = new File (myFilePath);
mySetProcFile.open("w");
mySetProcFile.writeln(myTB);
mySetProcFile.writeln(myTA);
mySetProcFile.writeln(mySС);
mySetProcFile.writeln(myArrRez[3]);
//mySetProcFile.writeln(myArrRez[4]);
myWindow.close();
var myDate = new Date;
var myTimeStart = myDate.getTime();
var myHour = myDate.getHours();
var myMinutes = myDate.getMinutes();
if (myHour <10) myHour = "0" + myHour;
if (myMinutes <10) myMinutes = "0" + myMinutes;
var myCounter = 0;
if (myArrRez[4] == 1) { // == вывод на экран прогрессбара
var pBar = new ProgressBar(ProgramTitul);
pBar.reset(" Время начала нумерации [ч:м] " + myHour + ":" +myMinutes, myDocument.pages.length);
for (var i = 0; i < myDocument.pages.length; i++, pBar.hit()) { // myDocument.pages.length	
	var my_PageItem = myDocument.pages[i].pageItems;
	for (var ii = 0; ii < my_PageItem.length; ii++) { // ii = my_PageItem.length	
		if (my_PageItem[ii].label == myLabel) { // == myLabel		 			
                  my_PageItem[ii].contents = String(myTB + NomerShow(myCounter * myIncr+mySN) + myTA);
				myCounter++;				
			}  // == myLabel
	} // ii = my_PageItem.length
} // myDocument.pages.length
pBar.close();    
} // == вывод на экран прогрессбара
else { // == без прогрессбара
for (var i = 0; i < myDocument.pages.length; i++) { // myDocument.pages.length	
	var my_PageItem = myDocument.pages[i].pageItems;
	for (var ii = 0; ii < my_PageItem.length; ii++) { // ii = my_PageItem.length	
		if (my_PageItem[ii].label == myLabel) { // == myLabel		 			
                  my_PageItem[ii].contents = String(myTB + NomerShow(myCounter * myIncr+mySN) + myTA);
				myCounter++;				
			}  // == myLabel
	} // ii = my_PageItem.length
} // myDocument.pages.length
} // == без прогрессбара

myCounter--;
var myDateFinish = new Date;
var myTimeFinis = myDateFinish.getTime();
var myTime = myTimeFinis - myTimeStart;
var mySpeed = (myTime/myCounter).toFixed(1);
var myProcTime = "\n\nВремя обработки: " +myTime + " миллисекунд.\nТемп нумерации: " + mySpeed + " миллисекунды на один номер.\n";
var myNF = NomerShow(myCounter * myIncr+mySN);
alert("Первый номер "+ mySС +", последний "+ myNF + ", шаг наращения счетчика " + myIncr + "." + myProcTime,ProgramTitul);
exit();
} // switch
alert("Выбранный объект не является текстовым фреймом.",ProgramTitul);
exit();
} // ==1
alert("Перед запуском скрипта надо выделить текстовый фрейм на мастер-странице, в котором будет один из номеров разворотов. Этот фрейм должен иметь метку.\nСейчас или не выделено ничего, или выделено несколько объектов.",ProgramTitul);
exit();
} // app.doc 
alert("Нет открытых документов.",ProgramTitul);
exit();
} // main

main();
/////
function NomerShow(myNmr) {
var myV = myRL - String(myNmr).length;
if (myV <= 0) return String(myNmr);
else {
	var myL = String(myNmr);
	for (d=0; d < myV; d++) {
		myL = "0" + myL;
		}
return myL;
}
} // NomerShow
//////////
function myFile(myFileName) {
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
//if(File(myFilePath).exists == false){
		/*Display a dialog.
		myFilePath = File.openDialog("Choose the file containing your find/change list"); */
		//----alert("Не найден файл " +  myFileName + " Он должен быть в том же каталоге, где размещен этот скрипт. ");
		//exit();
//		}
return myFilePath;
} //myFile
//
function myGetScriptPath() {
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()
/////////////


